package net.horizoncode.nekorip;

import lombok.Getter;
import net.horizoncode.nekorip.config.Config;
import net.horizoncode.nekorip.mysql.MySQLAPI;
import org.apache.commons.lang3.Validate;

import java.io.File;

/**
 * Created by HorizonCode at 10/05/2021
 *
 * @author HorizonCode
 * @since 10/05/2021
 **/
@Getter
public class NekoRIP {

    private static NekoRIP instance;

    private Config config;
    private MySQLAPI mySQL;

    public static void main(String[] args) {
        new NekoRIP().init();
    }

    private void init() {
        Validate.isTrue(instance == null, "Instance is already initialized.");
        instance = this;

        File config = new File("config.toml");
        this.config = new Config(config);

        if(this.config.isJustCreated()){
            System.out.println("No config found, created one. Please edit the config!");
            System.gc();
            System.exit(0);
            return;
        }

        String host = this.config.getStringOrDefault("mysql.host", "");
        int port = this.config.getIntOrDefault("mysql.port", 3306);
        String database = this.config.getStringOrDefault("mysql.database", "nekorip");
        String username = this.config.getStringOrDefault("mysql.username", "root");
        String password = this.config.getStringOrDefault("mysql.password", "");

        mySQL = MySQLAPI.getInstance();
        if(!mySQL.connect(host, port, username, password, database))
            System.out.println("Failed to connect to mysql.");

    }

}
